## ms-gsl 0~git20170403.ebab8ca

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(GSL CXX)

install(
    DIRECTORY include/gsl
    DESTINATION include
)

enable_testing()
add_subdirectory(tests)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(GSLTests CXX)

if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/unittest-cpp/tests)
    execute_process(COMMAND git submodule update --init WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

add_subdirectory(unittest-cpp)

include_directories(
    ../include
    ./unittest-cpp
)

add_definitions(-DGSL_THROW_ON_CONTRACT_VIOLATION)

if(MSVC) # has the support we need
    # remove unnecessary warnings about unchecked iterators
    add_definitions(-D_SCL_SECURE_NO_WARNINGS)
    add_compile_options(/EHsc /W4)
else()
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    if(COMPILER_SUPPORTS_CXX14)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing -std=c++14 -O3 -Wall -Wextra -Wpedantic -Wno-missing-braces -Wconversion -Wsign-conversion -Wctor-dtor-privacy -Wshadow -Wnon-virtual-dtor -Wold-style-cast -Wcast-align -Woverloaded-virtual")
    elseif(COMPILER_SUPPORTS_CXX11)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing -std=c++11 -O3 -Wall -Wextra -Wpedantic -Wno-missing-braces -Wconversion -Wsign-conversion -Wctor-dtor-privacy -Wshadow -Wnon-virtual-dtor -Wold-style-cast -Wcast-align -Woverloaded-virtual")
    else()
      message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
    endif()
endif()

function(add_gsl_test name)
    add_executable(${name} ${name}.cpp)
    target_link_libraries(${name} UnitTest++)
    add_test(
      ${name}
      ${name}
    )
endfunction()

add_gsl_test(span_tests)
add_gsl_test(multi_span_tests)
add_gsl_test(strided_span_tests)
add_gsl_test(string_span_tests)
add_gsl_test(at_tests)
add_gsl_test(bounds_tests)
add_gsl_test(notnull_tests)
add_gsl_test(assertion_tests)
add_gsl_test(utils_tests)
add_gsl_test(owner_tests)
add_gsl_test(byte_tests)
add_gsl_test(algorithm_tests)

=== debian/changelog ===
ms-gsl (0~git20170403.ebab8ca-1) unstable; urgency=low

  * Initial upload (closes: #859221)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 06 Apr 2017 07:12:01 +0300

=== debian/control ===
Source: ms-gsl
Section: libdevel
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: cmake (>=2.8.7),
               debhelper (>=10),
               libunittest++-dev
Standards-Version: 3.9.8
Homepage: https://github.com/Microsoft/GSL

Package: libmsgsl-dev
Architecture: all
Depends: ${misc:Depends}
Description: Microsoft Guidelines Support Library
 The Guideline Support Library (GSL) contains functions and types that are
 suggested for use by the C++ Core Guidelines maintained by the Standard C++
 Foundation. This package contains Microsoft's implementation of GSL.
 .
 The library includes types like span<T>, string_span, owner<> and others.
 .
 The entire implementation is provided inline in the headers under the gsl
 directory. The implementation generally assumes a platform that implements
 C++14 support.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Upstream does not provide a tarball
get-orig-source:
	git clone https://github.com/Microsoft/GSL
	tar --exclude-vcs -cJf ../ms-gsl_0~git$$(cd GSL && git log -1 --date="format:%Y%m%d" --format="%cd.%h").orig.tar.xz GSL
	rm -rf GSL

## ms-gsl 0~git20170602.1f87ef7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(GSL CXX)

# creates a library GSL which is an interface (header files only)
add_library(GSL INTERFACE)

# when minimum version required is 3.8.0 remove if below
# both branches do exactly the same thing
if ( CMAKE_MAJOR_VERSION VERSION_LESS 3.7.9)
    if (NOT MSVC)
        include(CheckCXXCompilerFlag)
        CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
        if(COMPILER_SUPPORTS_CXX14)
            target_compile_options(GSL INTERFACE "-std=c++14")
        else()
            message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support. Please use a different C++ compiler.")
        endif()
        
    endif()
else ()
    # set the GSL library to be compiled only with c++14
    target_compile_features(GSL INTERFACE cxx_std_14)
    # on *nix systems force the use of -std=c++XX instead of -std=gnu++XX (default)
    set(CMAKE_CXX_EXTENSIONS OFF)
endif()

# add definitions to the library and targets that consume it
target_compile_definitions(GSL INTERFACE
    $<$<CXX_COMPILER_ID:MSVC>:
        # remove unnecessary warnings about unchecked iterators
        _SCL_SECURE_NO_WARNINGS
    >
)

# add include folders to the library and targets that consume it
target_include_directories(GSL INTERFACE
    $<BUILD_INTERFACE:
        ${CMAKE_CURRENT_SOURCE_DIR}/include
    >
)

# add natvis file to the library so it will automatically be loaded into Visual Studio
target_sources(GSL INTERFACE 
    ${CMAKE_CURRENT_SOURCE_DIR}/GSL.natvis
)

install(
    DIRECTORY include/gsl
    DESTINATION include
)

enable_testing()
add_subdirectory(tests)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(GSLTests CXX)

# will make visual studio generated project group files
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/unittest-cpp/CMakeLists.txt)
    find_package(Git)
    execute_process(
        COMMAND ${GIT_EXECUTABLE} submodule update --init
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    )
endif()

add_subdirectory(unittest-cpp)

# this interface adds compile options to how the tests are run
# please try to keep entries ordered =)
add_library(gsl_tests_config INTERFACE)
target_compile_options(gsl_tests_config INTERFACE
    $<$<CXX_COMPILER_ID:MSVC>:
        /EHsc
        /W4
        /WX
    >
    $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:
        -fno-strict-aliasing
        -Wall
        -Wcast-align
        -Wconversion
        -Wctor-dtor-privacy
        -Werror
        -Wextra
        -Wno-missing-braces
        -Wnon-virtual-dtor
        -Wold-style-cast
        -Woverloaded-virtual
        -Wpedantic
        -Wshadow
        -Wsign-conversion
    >
)

# set test to include the unittest-cpp headers
# this shiuld be removed when UnitTest++ has the proper headers
target_include_directories(gsl_tests_config INTERFACE
    ./unittest-cpp
)

# set definitions for tests
target_compile_definitions(gsl_tests_config INTERFACE
    GSL_THROW_ON_CONTRACT_VIOLATION
)

function(add_gsl_test name)
    add_executable(${name} ${name}.cpp)
    target_link_libraries(${name}
        UnitTest++
        GSL
        gsl_tests_config
    )
    add_test(
      ${name}
      ${name}
    )
    # group all tests under GSL_tests
    set_property(TARGET ${name} PROPERTY FOLDER "GSL_tests")
endfunction()

add_gsl_test(span_tests)
add_gsl_test(multi_span_tests)
add_gsl_test(strided_span_tests)
add_gsl_test(string_span_tests)
add_gsl_test(at_tests)
add_gsl_test(bounds_tests)
add_gsl_test(notnull_tests)
add_gsl_test(assertion_tests)
add_gsl_test(utils_tests)
add_gsl_test(owner_tests)
add_gsl_test(byte_tests)
add_gsl_test(algorithm_tests)

=== debian/changelog ===
ms-gsl (0~git20170602.1f87ef7-2) unstable; urgency=medium

  * Apply patch that fixes tests, from pull request #526 (closes: #871070)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 17 Aug 2017 22:35:17 +0300

ms-gsl (0~git20170602.1f87ef7-1) unstable; urgency=medium

  * Merge the latest upstream commit
  * Update a patch, fix build against new unittest++ (closes: #865309)
  * Bump Standards-Version to 4.0.0, no changes for this

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 04 Jul 2017 14:35:04 +0300

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,14 @@
 Build-Depends: cmake (>=2.8.7),
                debhelper (>=10),
                libunittest++-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://github.com/Microsoft/GSL
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/ms-gsl.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/ms-gsl.git
 
 Package: libmsgsl-dev
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Microsoft Guidelines Support Library
  The Guideline Support Library (GSL) contains functions and types that are

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Upstream does not provide a tarball
get-orig-source:
	git clone --depth=1 https://github.com/Microsoft/GSL
	tar --exclude-vcs -cJf ../ms-gsl_0~git$$(cd GSL && git log -1 \
		--date="format:%Y%m%d" --format="%cd.%h").orig.tar.xz GSL
	rm -rf GSL

## ms-gsl 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,22 @@
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 3.7)
 
 project(GSL CXX)
+
+include(ExternalProject)
+find_package(Git)
 
 # creates a library GSL which is an interface (header files only)
 add_library(GSL INTERFACE)
 
+# determine whether this is a standalone project or included by other projects
+set(GSL_STANDALONE_PROJECT OFF)
+if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+  set(GSL_STANDALONE_PROJECT ON)
+endif ()
+
 # when minimum version required is 3.8.0 remove if below
 # both branches do exactly the same thing
-if ( CMAKE_MAJOR_VERSION VERSION_LESS 3.7.9)
+if (CMAKE_VERSION VERSION_LESS 3.7.9)
     if (NOT MSVC)
         include(CheckCXXCompilerFlag)
         CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
@@ -16,7 +25,7 @@
         else()
             message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support. Please use a different C++ compiler.")
         endif()
-        
+
     endif()
 else ()
     # set the GSL library to be compiled only with c++14
@@ -40,15 +49,26 @@
     >
 )
 
+if (MSVC_IDE)
+    option(VS_ADD_NATIVE_VISUALIZERS "Configure project to use Visual Studio native visualizers" TRUE)
+else()
+    set(VS_ADD_NATIVE_VISUALIZERS FALSE CACHE INTERNAL "Native visualizers are Visual Studio extension" FORCE)
+endif()
+
 # add natvis file to the library so it will automatically be loaded into Visual Studio
-target_sources(GSL INTERFACE 
-    ${CMAKE_CURRENT_SOURCE_DIR}/GSL.natvis
-)
+if(VS_ADD_NATIVE_VISUALIZERS)
+    target_sources(GSL INTERFACE
+        ${CMAKE_CURRENT_SOURCE_DIR}/GSL.natvis
+    )
+endif()
 
 install(
     DIRECTORY include/gsl
     DESTINATION include
 )
 
-enable_testing()
-add_subdirectory(tests)
+option(GSL_TEST "Generate tests." ${GSL_STANDALONE_PROJECT})
+if (GSL_TEST)
+	enable_testing()
+	add_subdirectory(tests)
+endif ()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -5,15 +5,26 @@
 # will make visual studio generated project group files
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 
-if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/unittest-cpp/CMakeLists.txt)
-    find_package(Git)
-    execute_process(
-        COMMAND ${GIT_EXECUTABLE} submodule update --init
-        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
+list(APPEND CATCH_CMAKE_ARGS
+    "-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/external"
+    "-DNO_SELFTEST=true"
+)
+
+if(GIT_FOUND)
+    # add catch
+    ExternalProject_Add(
+        catch
+        PREFIX ${CMAKE_BINARY_DIR}/catch
+        GIT_REPOSITORY https://github.com/catchorg/Catch2.git
+        GIT_TAG v2.0.1
+        CMAKE_ARGS ${CATCH_CMAKE_ARGS}
+        LOG_DOWNLOAD 1
+        UPDATE_DISCONNECTED 1
     )
+else()
+    # assume catch is installed in a system directory
+    add_custom_target(catch)
 endif()
-
-add_subdirectory(unittest-cpp)
 
 # this interface adds compile options to how the tests are run
 # please try to keep entries ordered =)
@@ -42,10 +53,9 @@
     >
 )
 
-# set test to include the unittest-cpp headers
-# this shiuld be removed when UnitTest++ has the proper headers
+# for tests to find the catch header
 target_include_directories(gsl_tests_config INTERFACE
-    ./unittest-cpp
+    ${CMAKE_BINARY_DIR}/external/include
 )
 
 # set definitions for tests
@@ -53,13 +63,24 @@
     GSL_THROW_ON_CONTRACT_VIOLATION
 )
 
+# create the main executable for each test. this reduces the compile time
+# of each test by pre-compiling catch.
+add_library(test_catch STATIC test.cpp)
+target_link_libraries(test_catch
+    GSL
+    gsl_tests_config
+)
+add_dependencies(test_catch catch)
+set_property(TARGET test_catch PROPERTY FOLDER "GSL_tests")
+
 function(add_gsl_test name)
     add_executable(${name} ${name}.cpp)
     target_link_libraries(${name}
-        UnitTest++
         GSL
+        test_catch
         gsl_tests_config
     )
+    add_dependencies(${name} catch)
     add_test(
       ${name}
       ${name}
@@ -80,3 +101,64 @@
 add_gsl_test(owner_tests)
 add_gsl_test(byte_tests)
 add_gsl_test(algorithm_tests)
+
+
+# No exception tests
+
+foreach(flag_var
+        CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
+        CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
+    STRING (REGEX REPLACE "/EHsc" "" ${flag_var} "${${flag_var}}")
+endforeach(flag_var)
+
+# this interface adds compile options to how the tests are run
+# please try to keep entries ordered =)
+add_library(gsl_tests_config_noexcept INTERFACE)
+target_compile_options(gsl_tests_config_noexcept INTERFACE
+    $<$<CXX_COMPILER_ID:MSVC>:
+        /D_HAS_EXCEPTIONS=0
+        /wd4702
+        /wd4577
+        /W4
+        /WX
+    >
+    $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:
+        -fno-strict-aliasing
+        -fno-exceptions
+        -Wall
+        -Wcast-align
+        -Wconversion
+        -Wctor-dtor-privacy
+        -Werror
+        -Wextra
+        -Wno-missing-braces
+        -Wnon-virtual-dtor
+        -Wold-style-cast
+        -Woverloaded-virtual
+        -Wpedantic
+        -Wshadow
+        -Wsign-conversion
+    >
+)
+
+# set definitions for tests
+target_compile_definitions(gsl_tests_config_noexcept INTERFACE
+    GSL_TERMINATE_ON_CONTRACT_VIOLATION
+)
+
+function(add_gsl_test_noexcept name)
+    add_executable(${name} ${name}.cpp)
+    target_link_libraries(${name}
+        GSL
+        gsl_tests_config_noexcept
+    )
+    add_test(
+      ${name}
+      ${name}
+    )
+    # group all tests under GSL_tests_noexcept
+    set_property(TARGET ${name} PROPERTY FOLDER "GSL_tests_noexcept")
+endfunction()
+
+add_gsl_test_noexcept(no_exception_throw_tests)
+add_gsl_test_noexcept(no_exception_ensure_tests)

=== debian/changelog ===
ms-gsl (1.0.0-2) unstable; urgency=medium

  * Add Catch-Classic-Workaround.patch (closes: #906385).
    - Redefine a macro for compatibility with Catch 1.x.x.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 25 Aug 2018 13:31:02 +0300

ms-gsl (1.0.0-1) unstable; urgency=medium

  * New upstream release.
    - Replace the libunittest++-dev build dependency with the catch framework.
  * Move the repository of the package to salsa.debian.org.
  * Create the debain/watch file for tracking upstream versions.
  * Add support for the nocheck build profile
  * Update patches.
    - Fix-GCC-Build.patch: New fix of tests taken from already merged pull
      request.
  * Bump debhelper version to 11 and standards version to 4.1.5.
    - Add the Rules-Requires-Root field into debian/control.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 07 Jul 2018 13:26:34 +0300

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: cmake (>=2.8.7),
-               debhelper (>=10),
-               libunittest++-dev
-Standards-Version: 4.0.0
+Build-Depends: debhelper (>=11)
+Build-Depends-Indep: catch <!nocheck>, cmake (>=3.7)
+Standards-Version: 4.1.5
+Rules-Requires-Root: no
 Homepage: https://github.com/Microsoft/GSL
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/ms-gsl.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/ms-gsl.git
+Vcs-Git: https://salsa.debian.org/debian/ms-gsl.git
+Vcs-Browser: https://salsa.debian.org/debian/ms-gsl
 
 Package: libmsgsl-dev
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

EXTRA_CMAKE_VARIABLES += CMAKE_DISABLE_FIND_PACKAGE_Git=ON
ifneq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
 EXTRA_CMAKE_VARIABLES += GSL_TEST=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

## ms-gsl 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(GSL CXX)

include(ExternalProject)
find_package(Git)

# creates a library GSL which is an interface (header files only)
add_library(GSL INTERFACE)

# determine whether this is a standalone project or included by other projects
set(GSL_STANDALONE_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(GSL_STANDALONE_PROJECT ON)
endif ()

set(GSL_CXX_STANDARD "14" CACHE STRING "Use c++ standard")
set(GSL_CXX_STD "cxx_std_${GSL_CXX_STANDARD}")

if (MSVC)
    set(GSL_CXX_STD_OPT "-std:c++${GSL_CXX_STANDARD}")
else()
    set(GSL_CXX_STD_OPT "-std=c++${GSL_CXX_STANDARD}")
endif()

# when minimum version required is 3.8.0 remove if below
# both branches do exactly the same thing
if (CMAKE_VERSION VERSION_LESS 3.7.9)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("${GSL_CXX_STD_OPT}" COMPILER_SUPPORTS_CXX_STANDARD)

    if(COMPILER_SUPPORTS_CXX_STANDARD)
        target_compile_options(GSL INTERFACE "${GSL_CXX_STD_OPT}")
    else()
        message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no c++${GSL_CXX_STANDARD} support. Please use a different C++ compiler.")
    endif()
else ()
    target_compile_features(GSL INTERFACE "${GSL_CXX_STD}")
    # on *nix systems force the use of -std=c++XX instead of -std=gnu++XX (default)
    set(CMAKE_CXX_EXTENSIONS OFF)
endif()

# add definitions to the library and targets that consume it
target_compile_definitions(GSL INTERFACE
    $<$<CXX_COMPILER_ID:MSVC>:
        # remove unnecessary warnings about unchecked iterators
        _SCL_SECURE_NO_WARNINGS
        # remove deprecation warnings about std::uncaught_exception() (from catch)
        _SILENCE_CXX17_UNCAUGHT_EXCEPTION_DEPRECATION_WARNING
    >
)

# add include folders to the library and targets that consume it
# the SYSTEM keyword suppresses warnings for users of the library
if(GSL_STANDALONE_PROJECT)
    target_include_directories(GSL INTERFACE
        $<BUILD_INTERFACE:
            ${CMAKE_CURRENT_SOURCE_DIR}/include
        >
    )
else()
    target_include_directories(GSL SYSTEM INTERFACE
        $<BUILD_INTERFACE:
            ${CMAKE_CURRENT_SOURCE_DIR}/include
        >
    )
endif()


if (CMAKE_VERSION VERSION_GREATER 3.7.8)
    if (MSVC_IDE)
        option(VS_ADD_NATIVE_VISUALIZERS "Configure project to use Visual Studio native visualizers" TRUE)
    else()
        set(VS_ADD_NATIVE_VISUALIZERS FALSE CACHE INTERNAL "Native visualizers are Visual Studio extension" FORCE)
    endif()

    # add natvis file to the library so it will automatically be loaded into Visual Studio
    if(VS_ADD_NATIVE_VISUALIZERS)
        target_sources(GSL INTERFACE
            ${CMAKE_CURRENT_SOURCE_DIR}/GSL.natvis
        )
    endif()
endif()

install(
    DIRECTORY include/gsl
    DESTINATION include
)

option(GSL_TEST "Generate tests." ${GSL_STANDALONE_PROJECT})
if (GSL_TEST)
	enable_testing()
	add_subdirectory(tests)
endif ()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 3.0.2)
 
 project(GSLTests CXX)
 
@@ -26,16 +26,31 @@
     add_custom_target(catch)
 endif()
 
+if (MSVC AND (GSL_CXX_STANDARD EQUAL 17))
+    set(GSL_CPLUSPLUS_OPT -Zc:__cplusplus -permissive-)
+endif()
+
 # this interface adds compile options to how the tests are run
 # please try to keep entries ordered =)
 add_library(gsl_tests_config INTERFACE)
-target_compile_options(gsl_tests_config INTERFACE
-    $<$<CXX_COMPILER_ID:MSVC>:
+if(MSVC) # MSVC or simulating MSVC
+    target_compile_options(gsl_tests_config INTERFACE
+        ${GSL_CPLUSPLUS_OPT}
         /EHsc
         /W4
         /WX
-    >
-    $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:
+        $<$<CXX_COMPILER_ID:Clang>:
+          -Weverything
+          -Wno-c++98-compat
+          -Wno-c++98-compat-pedantic
+          -Wno-missing-braces
+          -Wno-missing-prototypes
+          -Wno-unknown-attributes
+          $<$<EQUAL:${GSL_CXX_STANDARD},14>:-Wno-unused-member-function>
+        >
+    )
+else()
+    target_compile_options(gsl_tests_config INTERFACE
         -fno-strict-aliasing
         -Wall
         -Wcast-align
@@ -43,15 +58,25 @@
         -Wctor-dtor-privacy
         -Werror
         -Wextra
-        -Wno-missing-braces
-        -Wnon-virtual-dtor
-        -Wold-style-cast
-        -Woverloaded-virtual
         -Wpedantic
         -Wshadow
         -Wsign-conversion
-    >
-)
+        $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>>:
+          -Weverything
+          -Wno-c++98-compat
+          -Wno-c++98-compat-pedantic
+          -Wno-missing-braces
+          -Wno-missing-prototypes
+          -Wno-padded
+          -Wno-unknown-attributes
+          $<$<EQUAL:${GSL_CXX_STANDARD},14>:-Wno-unused-member-function>
+          -Wno-weak-vtables
+        >
+        $<$<CXX_COMPILER_ID:Clang>:
+          $<$<CXX_COMPILER_VERSION:5.0.2>:-Wno-undefined-func-template>
+        >
+    )
+endif(MSVC)
 
 # for tests to find the catch header
 target_include_directories(gsl_tests_config INTERFACE
@@ -101,6 +126,7 @@
 add_gsl_test(owner_tests)
 add_gsl_test(byte_tests)
 add_gsl_test(algorithm_tests)
+add_gsl_test(strict_notnull_tests)
 
 
 # No exception tests
@@ -114,32 +140,49 @@
 # this interface adds compile options to how the tests are run
 # please try to keep entries ordered =)
 add_library(gsl_tests_config_noexcept INTERFACE)
-target_compile_options(gsl_tests_config_noexcept INTERFACE
-    $<$<CXX_COMPILER_ID:MSVC>:
-        /D_HAS_EXCEPTIONS=0
-        /wd4702
-        /wd4577
+if(MSVC) # MSVC or simulating MSVC
+    target_compile_definitions(gsl_tests_config_noexcept INTERFACE
+        _HAS_EXCEPTIONS=0
+    )
+    target_compile_options(gsl_tests_config_noexcept INTERFACE
+        ${GSL_CPLUSPLUS_OPT}
         /W4
         /WX
-    >
-    $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:
+        $<$<CXX_COMPILER_ID:MSVC>:
+          /wd4577
+          /wd4702
+        >
+        $<$<CXX_COMPILER_ID:Clang>:
+          -Weverything
+          -Wno-c++98-compat
+          -Wno-c++98-compat-pedantic
+          -Wno-missing-prototypes
+          -Wno-unknown-attributes
+        >
+    )
+else()
+    target_compile_options(gsl_tests_config_noexcept INTERFACE
+        -fno-exceptions
         -fno-strict-aliasing
-        -fno-exceptions
         -Wall
         -Wcast-align
         -Wconversion
         -Wctor-dtor-privacy
         -Werror
         -Wextra
-        -Wno-missing-braces
-        -Wnon-virtual-dtor
-        -Wold-style-cast
-        -Woverloaded-virtual
         -Wpedantic
         -Wshadow
         -Wsign-conversion
-    >
-)
+        $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>>:
+          -Weverything
+          -Wno-c++98-compat
+          -Wno-c++98-compat-pedantic
+          -Wno-missing-prototypes
+          -Wno-unknown-attributes
+          -Wno-weak-vtables
+        >
+    )
+endif(MSVC)
 
 # set definitions for tests
 target_compile_definitions(gsl_tests_config_noexcept INTERFACE

=== debian/changelog ===
ms-gsl (2.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Patches:
    - Drop no more needed Fix-GCC-Build.patch
    - Update Catch-Classic-Workaround.patch
  * Bump Standards-Version to 4.5.0, no related changes.
  * Bump debhelper-compat to 12, no releted changes.
  * Clarify required CMake version 3.1.3.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 28 Feb 2020 13:59:40 +0300

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: debhelper (>=11)
-Build-Depends-Indep: catch <!nocheck>, cmake (>=3.7)
-Standards-Version: 4.1.5
+Build-Depends: debhelper-compat (= 12)
+Build-Depends-Indep: catch <!nocheck>, cmake (>= 3.1.3)
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/Microsoft/GSL
 Vcs-Git: https://salsa.debian.org/debian/ms-gsl.git

=== debian/rules ===
#!/usr/bin/make -f

EXTRA_CMAKE_VARIABLES += \
	CMAKE_DISABLE_FIND_PACKAGE_Git=ON \
	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON
ifneq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
 EXTRA_CMAKE_VARIABLES += GSL_TEST=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

## ms-gsl 3.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,12 @@
-cmake_minimum_required(VERSION 3.1.3)
+cmake_minimum_required(VERSION 3.1.3...3.16)
 
 project(GSL CXX)
 
 include(ExternalProject)
 find_package(Git)
+
+# Use GNUInstallDirs to provide the right locations on all platforms
+include(GNUInstallDirs)
 
 # creates a library GSL which is an interface (header files only)
 add_library(GSL INTERFACE)
@@ -54,15 +57,13 @@
 # the SYSTEM keyword suppresses warnings for users of the library
 if(GSL_STANDALONE_PROJECT)
     target_include_directories(GSL INTERFACE
-        $<BUILD_INTERFACE:
-            ${CMAKE_CURRENT_SOURCE_DIR}/include
-        >
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
     )
 else()
     target_include_directories(GSL SYSTEM INTERFACE
-        $<BUILD_INTERFACE:
-            ${CMAKE_CURRENT_SOURCE_DIR}/include
-        >
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
     )
 endif()
 
@@ -77,15 +78,23 @@
     # add natvis file to the library so it will automatically be loaded into Visual Studio
     if(VS_ADD_NATIVE_VISUALIZERS)
         target_sources(GSL INTERFACE
-            ${CMAKE_CURRENT_SOURCE_DIR}/GSL.natvis
+            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/GSL.natvis>
         )
     endif()
 endif()
 
+install(TARGETS GSL EXPORT Microsoft.GSLConfig)
 install(
     DIRECTORY include/gsl
-    DESTINATION include
+    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
 )
+# Make library importable by other projects
+install(EXPORT Microsoft.GSLConfig NAMESPACE Microsoft.GSL:: DESTINATION ${CMAKE_INSTALL_DATADIR}/cmake/Microsoft.GSL)
+export(TARGETS GSL NAMESPACE Microsoft.GSL:: FILE Microsoft.GSLConfig.cmake)
+
+# Add Microsoft.GSL::GSL alias for GSL so that dependents can be agnostic about
+# whether GSL was added via `add_subdirectory` or `find_package`
+add_library(Microsoft.GSL::GSL ALIAS GSL)
 
 option(GSL_TEST "Generate tests." ${GSL_STANDALONE_PROJECT})
 if (GSL_TEST)

=== debian/changelog ===
ms-gsl (3.0.1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 08 May 2020 12:57:17 -0700

ms-gsl (3.0.1-1) unstable; urgency=medium

  * New upstream release.
    - Switch to GoogleTest framework.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 26 Apr 2020 17:35:55 +0300

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,13 @@
 Source: ms-gsl
 Section: libdevel
 Priority: optional
-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
 Build-Depends: debhelper-compat (= 12)
-Build-Depends-Indep: catch <!nocheck>, cmake (>= 3.1.3)
+Build-Depends-Indep:
+ cmake (>= 3.1.3),
+ libgtest-dev <!nocheck>,
+ pkg-config <!nocheck>,
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/Microsoft/GSL

## ms-gsl 3.1.0

=== debian/changelog ===
ms-gsl (3.1.0-4ubuntu3) impish; urgency=medium

  * Add test dependendency on libunwind-13-dev, except on s390x

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 22 Sep 2021 07:31:12 +0000

ms-gsl (3.1.0-4ubuntu2) impish; urgency=medium

  * Add test dependendency on libunwind-13-dev

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Sep 2021 16:14:27 +0000

ms-gsl (3.1.0-4ubuntu1) hirsute; urgency=medium

  * Skip new clang test on s390x (see: #974841)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 29 Dec 2020 16:15:21 +0100

ms-gsl (3.1.0-4) unstable; urgency=medium

  * Run autopkgtests only against default GCC and Clang (closes: #976037).
  * Bump Standards-Versions to 4.5.1, no related changes for this.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 27 Dec 2020 17:13:40 +0300

ms-gsl (3.1.0-3) unstable; urgency=medium

  * Build GoogleTest framework before testing GSL (closes: #972944).
  * Do auto-tests with Clang as well.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 01 Nov 2020 19:15:53 +0300

ms-gsl (3.1.0-2) unstable; urgency=medium

  * New Move-array-bounds-tests.patch (closes: #966895).
    - Use independent translation unit to bypass an error caused by
      "-Warray-bounds" flag.
  * Add autopkgtests with various GCC versions and C++ standards.
  * Update DebHelper compatibility level to 13.
    - Remove no longer needed the CMAKE_SKIP_INSTALL_ALL_DEPENDENCY variable
      from the debian/rules file.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 20 Aug 2020 07:42:55 +0300

ms-gsl (3.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Add upstream metadata.
  * Add "Revert-Drop-ARCH_INDEPENDENT.patch"
    - This fixes build library consumers on 32-bit architectures.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 06 Jun 2020 22:00:01 +0300

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: ms-gsl
 Section: libdevel
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: debhelper-compat (= 12)
+Build-Depends: debhelper-compat (= 13)
 Build-Depends-Indep:
- cmake (>= 3.1.3),
+ cmake (>= 3.14),
  libgtest-dev <!nocheck>,
  pkg-config <!nocheck>,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/Microsoft/GSL
 Vcs-Git: https://salsa.debian.org/debian/ms-gsl.git

=== debian/tests/control ===
Tests: with-gcc-std14 with-gcc-std17 with-gcc-std20
Depends: cmake, g++, libgtest-dev, libmsgsl-dev, make, pkg-config
Restrictions: allow-stderr

Tests: with-clang-std14 with-clang-std17 with-clang-std20
Depends:
 clang,
 cmake,
 libc++-dev,
 libc++abi-dev,
 libgtest-dev,
 libmsgsl-dev,
 libunwind-13-dev [!s390x],
 make,
 pkg-config,
Restrictions: allow-stderr, skippable

## ms-gsl 4.0.0

=== debian/changelog ===
ms-gsl (4.0.0-2) unstable; urgency=medium

  * Ignore -Wpsabi warnings on PowerPC.
  * Skip Clang autopkgtests on IBM Z.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 05 Feb 2022 23:19:23 +0300

ms-gsl (4.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Delete patches. They are all applied by upstream.
  * Do not ignore compiler warnings in autopkgtests.
  * New smoke test to reveal errors with version numbers.
  * Bump Standards-Version to 4.6.0, no required changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 01 Feb 2022 00:29:03 +0300

=== debian/rules ===
#!/usr/bin/make -f

EXTRA_CMAKE_VARIABLES += CMAKE_DISABLE_FIND_PACKAGE_Git=ON
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
EXTRA_CMAKE_VARIABLES += GSL_TEST=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

=== debian/tests/control ===
Tests: smoke
Depends: cmake, g++ | c++-compiler, libmsgsl-dev, make
Restrictions: superficial

Tests: with-gcc-std14 with-gcc-std17 with-gcc-std20
Depends: cmake, g++, libgtest-dev, libmsgsl-dev, make, pkg-config

Tests: with-clang-std14 with-clang-std17 with-clang-std20
# There are problems with LLVM toolchain for IBM Z platform.
# See Debian bugs 974841, 1004914. So skip these tests for now.
Architecture: !s390x
Depends:
 clang,
 cmake,
 libc++-dev,
 libc++abi-dev,
 libgtest-dev,
 libmsgsl-dev,
 make,
 pkg-config,

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/Microsoft/GSL/releases/latest \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
